EZY Project/Controllers/InvoiceController.cs
using BAL.Repositories;
using DAL.DBEntities;
using EZY_Project.Models;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.tool.xml;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EZY_Project.Controllers
{
    public class InvoiceController : Controller
    {
        // GET: Invoice
        public ActionResult Index()
        {
            return View();
        }
        public void DownloadInvoice()
        {
            string viewPrint = "View";
            int CustomerId = Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[0]);
            //int month=  Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[1]);
            //int year = Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[2]);
            //string Type= Request.RawUrl.Split('/')[3].Split('-')[3];


            InvoiceStructure model = new CustomerRepository().GetCustomerById(CustomerId);
            string dataa = PartialView(viewPrint, model).RenderToString(this.ControllerContext);
            //dataa = dataa.Replace("/Content", folderPath);


            // vt_Common.RenderPartialToString(this, "PrintViewData", ModelData, VDD, TDD);
            StringReader sr = new StringReader(dataa);//Request.Form[hfGridHtml.UniqueID]
            Document pdfDoc = new Document(PageSize.A4, 10f, 10f, 20f, 20f);
            PdfWriter writer = PdfWriter.GetInstance(pdfDoc, Response.OutputStream);
            pdfDoc.Open();
            XMLWorkerHelper.GetInstance().ParseXHtml(writer, pdfDoc, sr);
            pdfDoc.Close();
            //string file = HostingEnvironment.MapPath("~/Template/clientregularization.pdf");
            Response.ContentType = "application/pdf";
            Response.AddHeader("content-disposition", "attachment;filename= Certificate.pdf");
            Response.Cache.SetCacheability(HttpCacheability.NoCache);

            Response.Write(pdfDoc);
            Response.OutputStream.Flush();
            Response.End();
        }
    }
}

EZY Project/Controllers/UserController.cs
using BAL.Repositories;
using DAL.DBEntities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EZY_Project.Controllers
{
    public class UserController : BaseController
    {

        UserRepository userrepo;

        public UserController()
        {
            userrepo = new UserRepository(new DAL.DBEntities.OMSEntities());
        }
        // GET: User
        public ActionResult Index()
        {
            return View(userrepo.Getuser());
        }

        [HttpGet]
        public ActionResult Create(string CustomerId)
        {
            var sess = CurrentUser;

            vt_User user = userrepo.GetuserbyId(Convert.ToInt32(CustomerId));

            try
            {


                List<SelectListItem> AllRegions = new List<SelectListItem>();
                SelectListItem ListItem = new SelectListItem();
                ListItem.Text = "--Select Region--";
                ListItem.Value = "";
                AllRegions.Add(ListItem);
                foreach (var item in userrepo.GetAllRegion())
                {
                    SelectListItem SelectListItem = new SelectListItem();
                    SelectListItem.Text = item.Region;
                    SelectListItem.Value = item.ID.ToString();
                    AllRegions.Add(SelectListItem);


                }

                List<SelectListItem> AllRoles = new List<SelectListItem>();
                ListItem = new SelectListItem();
                ListItem.Text = "--Select Role--";
                ListItem.Value = "";
                AllRoles.Add(ListItem);
                foreach (var item in userrepo.GetAllRole())
                {
                    SelectListItem SelectListItem = new SelectListItem();
                    SelectListItem.Text = item.Role;
                    SelectListItem.Value = item.ID.ToString();
                    AllRoles.Add(SelectListItem);

                }

                ViewBag.AllRegions = AllRegions;
                ViewBag.AllRoles = AllRoles;
            }
            catch (Exception ex)
            {

            }


            return PartialView("_Save", user);
        }

        [HttpPost]
        public ActionResult CreateUser(vt_User user)
        {
            var sess = CurrentUser;
            string msg = string.Empty;
            try
            {
                //if (ModelState.IsValid)
                //{
                    if (user.ID > 0)
                    {
                        userrepo.updateUserbyId(user);
                        msg = "Update User Successfully";
                        //if (!userrepo.CheckUserName(user.Email, user.CompanyId))
                        //{
                        //    userrepo.UpdateUser(user, sess.vt_user.id);
                        //}
                        //else
                        //{
                        //    var a = userrepo.GetUserById(user.id);
                        //    ViewBag.UserName = a.Email;
                        //    ViewBag.Company = userrepo.GetCompanys(sess.vt_user.CompanyId);
                        //    ViewBag.Title = "UserName Already Exist";
                        //    return PartialView("_Save", user);
                        //}
                    }
                    else
                    {
                        userrepo.InsertUser(user);
                        msg = "Insert User Successfully";
                        //if (userrepo.CheckUserName(user.Email, user.CompanyId))
                        //{
                        //    ViewBag.Company = userrepo.GetCompanys(sess.vt_user.CompanyId);
                        //    ViewBag.Title = "UserName Already Exist";
                        //    return PartialView("_Save", user);
                        //}
                        //else
                        //{
                        //    userrepo.InsertUser(user, sess.vt_user.id);
                        //}
                    }
                    List<SelectListItem> AllRegions = new List<SelectListItem>();
                    SelectListItem ListItem = new SelectListItem();
                    ListItem.Text = "--Select Region--";
                    ListItem.Value = "";
                    AllRegions.Add(ListItem);
                    foreach (var item in userrepo.GetAllRegion())
                    {
                        SelectListItem SelectListItem = new SelectListItem();
                        SelectListItem.Text = item.Region;
                        SelectListItem.Value = item.ID.ToString();
                        AllRegions.Add(SelectListItem);


                    }

                    List<SelectListItem> AllRoles = new List<SelectListItem>();
                    ListItem = new SelectListItem();
                    ListItem.Text = "--Select Role--";
                    ListItem.Value = "";
                    AllRoles.Add(ListItem);
                    foreach (var item in userrepo.GetAllRole())
                    {
                        SelectListItem SelectListItem = new SelectListItem();
                        SelectListItem.Text = item.Role;
                        SelectListItem.Value = item.ID.ToString();
                        AllRoles.Add(SelectListItem);

                    }

                    ViewBag.AllRegions = AllRegions;
                    ViewBag.AllRoles = AllRoles;
                    //return RedirectToAction("Index");
                    return Json(new { status=true,message= msg }, JsonRequestBehavior.AllowGet);
                //}

            }
            catch (Exception ex)
            {

            }
            return PartialView("_Save", user);

            //else
            //{
            //    ViewBag.Company = userrepo.GetCompanys(sess.vt_user.CompanyId);
            //    ViewBag.Title = "Fill All Required Fields";
            //    return PartialView("_Save", user);
            //}


        }

        public JsonResult DeleteUser(int id)
        {
            bool Status = false;
            try
            {

                if (userrepo.DeleteUserbyId(id) == true)
                {
                    Status = true;
                    //userrepo.SaveChanges();
                }
            }
            catch (Exception ex)
            {
                Status = false;
            }

            return Json(new { success = Status }, JsonRequestBehavior.AllowGet);
        }
    }
}

EZY Project/Views/User/Index.cshtml
@model IList<DAL.DBEntities.vt_User>
@{
    ViewBag.Title = "Index";
}
@*<link href="~/assets/css/validator.css" rel="stylesheet" />*@
<link href="~/scripts/notification/css/mk-notifications.css" rel="stylesheet" type="text/css">
<div class="row page-title clearfix">
    <div class="page-title-left">
        <h6 class="page-title-heading mr-0 mr-r-5">User</h6>
        <p class="page-title-description mr-0 d-none d-md-inline-block">Overview of your User</p>
    </div>
    <!-- /.page-title-left -->
    <div class="page-title-right d-none d-sm-inline-flex">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="javascript:;">Dashboard</a>
            </li>
            <li class="breadcrumb-item active">Users</li>
        </ol>
    </div>
    <!-- /.page-title-right -->
</div>


<div class="widget-list">
    <div class="row">
        <div class="widget-holder col-md-12">
            <div class="widget-bg">
                <div class="widget-body">
                    <div class="row">
                        <div class="col-sm-6">
                            <h5 class="box-title mt-2">Users</h5>
                        </div>
                        <div class="col-sm-6 text-right">
                            <a class="btn btn-pinterest ripple AddUser" href="javascript:;" _id="0" actionfor="Create">
                                <i class="material-icons list-icon"></i><span>Add User</span>
                            </a>

                            @*<a class="btn btn-pinterest ripple" href="@Url.Action("DownloadInvoice", "Invoice")">Download Pdf</a>
                                <a class="export" href="Customer/ExportCustomer">Export Customer</a>*@
                        </div>
                    </div>
                    <div id="devCustomerDataGrid" class="table table-striped"></div>

                    <div id="gridContainer"></div>
                    <table id="UserTable" class="tbl_expend_customer table tble_customer">
                        <thead>
                            <tr class="sm-text">
                                <th data-type="competency">First Name</th>
                                <th class="text-align-center" data-type="percent-above-score">Last Name</th>
                                <th data-type="average-score">Email</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @{
                                foreach (var item in Model)
                                {
                                    <tr data-node="treetable-650__1" data-pnode="">
                                        <td class="sm-text" data-code="A" data-competencyid="650-1">
                                            @item.FName
                                        </td>
                                        <td class="sm-text text-align-center">@item.LName</td>
                                        <td class="sm-text color-gray">@item.Email</td>
                                        <td class="">
                                            <button type="button" title="Edit User" class="Edit btn bg-blue-grey btn-circle waves-effect waves-circle waves-float" _id="@item.ID" actionfor="Edit">
                                                <i class="material-icons">mode_edit</i>
                                            </button>
                                            <button type="button" title="Delete User" class="Delete btn bg-blue-grey btn-circle waves-effect waves-circle waves-float" _id="@item.ID" actionfor="Delete">
                                                <i class="material-icons">clear</i>
                                            </button>
                                        </td>
                                    </tr>
                                }
                            }
                        </tbody>
                    </table>
                </div>
                <!-- /.widget-body -->
            </div>
            <!-- /.widget-bg -->
        </div>
        <!-- /.widget-holder -->
        <!-- /.widget-holder -->
        <!-- /.widget-holder -->
        <!-- /.widget-holder -->
    </div>
    <!-- /.row -->
    <!-- /.widget-body -->
</div>
<div id="ModalUser"></div>


@*<script src="~/scripts/jquery.validate.js"></script>
    <script src="~/scripts/jquery.validate.min.js"></script>
    <script src="~/scripts/jquery.validate.unobtrusive.js"></script>
    <script src="~/scripts/jquery.validate.unobtrusive.min.js"></script>
    <script src="~/scripts/jquery.toast.js"></script>
    <script src="~/scripts/jquery.validator.js"></script>
    <script src="~/scripts/Jquery-Validation-add-methods.js"></script>*@
<script src="~/scripts/notification/js/mk-notifications.js"></script>

@section InScript{
    <script type="text/javascript">
        $(document).ready(function () {
            $('.Delete').click(function () {
                debugger
                $('#DeleteConfirmation').find("#DeleteModalLabel").text("Delete User")
                $('#DeleteConfirmation').modal("show");
                $('#btnDeleteConfirmation').attr("deleteid", $(this).attr('_id'))
            });


            $("#btnDeleteConfirmation").click(function () {
                $.post("@Url.Action("DeleteUser", "User")", { id: $(this).attr('deleteid') }, function (data) {
                    if (data.success) {
                        debugger
                        $('#DeleteConfirmation').modal('hide');
                        window.location.reload();
                        mkNoti('Message', "User Delete Successfully",
                                            {
                                                status: 'success'
                                            });


                        //window.location.reload();
                        //showStatusMsgPopup("1", "Deleted Successfully");
                    }
                });
            });

            $(".AddUser,.Edit").click(function () {
                debugger
                var id = $(this).attr("_id");
                var Action = $(this).attr("actionfor");
                $.ajax({
                    type: "get",
                    url: "@Url.Action("Create", "User")",
                    data: { "CustomerId": id },
                    success: function (data) {
                        $('#ModalUser').html(data);
                        if (Action == "Edit") {
                            $('#UserModal').find("#UserModalLabel").text(Action + " User")
                            $('#UserModal').find('#btnSave').text("Update")
                            $('#UserModal').modal('show');
                        }
                        else {
                            $('#UserModal').find("#UserModalLabel").text(Action + " User")
                            $('#UserModal').modal('show');
                        }
                        //alert(data); ModelProduct
                    }
                })

            });

               
        });
   
    </script>
}